#include <dir.h>
#include <ctype.h>
#include <conio.h>
#include <stdio.h>
#include <string.h>
#include <process.h>

int process(char *act, char *line);

void main(int argc, char *argv[])
{
  char line[100];
  FILE *fp;
  struct ffblk dirblk;

  if(argc < 3)
  {
    printf("usage: proc action list/-d\n"
	   "performs action on each file on the list\n"
	   "or, if -d is the second parameter, all files in a directory\n"
	   "prompts yes/no for each file; ESC to stop\n");
    exit(1);
  }

  if(!strcmp(argv[2], "-d"))
  {
    if(!findfirst("*.*", &dirblk, 0))       /* if -d, process directory */
      do
	if(process(argv[1], dirblk.ff_name))
	  break;
      while(!findnext(&dirblk));
  }

  else                                      /* else process list */
  {
    if((fp = fopen(argv[2], "rt")) == NULL)
    {
      perror(argv[2]);
      exit(1);
    }

    while(fgets(line, 80, fp))
      if(process(argv[1], line))
	break;

    fclose(fp);
    printf("\ndelete file list(%s) (Y/n)? ", argv[2]);
    if(toupper(getche()) == 'Y')
      unlink(argv[2]);
  }

}

int process(char *act, char *line)
{
  int c;
  char action[100];

  if(line[(c = strlen(line) - 1)] == '\n')
    line[c] = 0;
  sprintf(action, "%s %s", act, line);

  printf("%s (y/N)? ", action);

  if((c = toupper(getche())) == 'Y')
    system(action);

  printf("\n");

  if(c == 27)           /* stop if user hits ESC */
    return(1);
  return(0);
}